=== debian/changelog ===
xeus (5.2.4-0.2) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * debian/control:
   - Remove Build-Depends on xtl-dev
   - Build-Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev
   - xeus-dev: 
     + Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev
     + Remove Depends on xtl-dev

 -- Bill Allombert <ballombe@debian.org>  Thu, 30 Oct 2025 22:41:58 +0100

xeus (5.2.4-0.1) experimental; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release.
  * debian/watch: add missing 'debian uupdate'
  * New upstream release
    - New soname: libxeus11 -> libxeus13
  * debian/control:
    - New library name: libxeus11 -> libxeus13
  * debian/libxeus11.install: rename to debian/libxeus13.install

 -- Bill Allombert <ballombe@debian.org>  Tue, 28 Oct 2025 15:54:31 +0100
