=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus/tags .*/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
