## xeus 5.2.6

=== debian/changelog ===
xeus (5.2.6-1) unstable; urgency=medium

  * New upstream release.
  * New maintainer.
  * debian/control:
    - Update Standards-Version to 4.7.2
    - libxeus13: mark Multi-Arch: same
    - Remove Vcs-Git, Vcs-Browser.

 -- Bill Allombert <ballombe@debian.org>  Sat, 29 Nov 2025 22:24:27 +0100
