=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: xeus
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Gordon Ball <gordon@chronitis.net>
+Maintainer: Bill Allombert <ballombe@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                nlohmann-json3.12-dev,
@@ -9,16 +8,15 @@
                libssl-dev,
                pkgconf,
                doctest-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/jupyter-xeus/xeus
-Vcs-Git: https://salsa.debian.org/science-team/xeus.git
-Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
 Package: libxeus13
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
 Description: C++ Implementation of the Jupyter Kernel protocol (library)
  xeus enables custom kernel authors to implement Jupyter kernels more
  easily. It takes the burden of implementing the Jupyter Kernel protocol
